/**
 * Informatique Industrielle et Java
 * Solution de l'exercice 2.8 du chapitre2
 *
 * @author F. Mallet et F. Boeri
 * @version 1
 */
public class CompteurModulo {
  private int etat = 0;
  private int modulo;
  public CompteurModulo(int modulo) {
    if (modulo<=0) {
      throw new RuntimeException("modulo doit ?tre >0");
    }
    this.modulo = modulo;
  }
  public int getEtat() { 
    return etat; 
  }
  public void incrementer() {
    if (etat == modulo-1) {
      etat = 0;
    } else {
      etat += 1;
    }
  }
  
  public void incrementer ( int nombre ) {
    assert (nombre>0 && nombre<modulo) ;
// si on est s?r de ne pas d?passer l'?tat limite 
    if ( etat < (modulo - nombre) ) { 
// l'?tat est incr?ment?
      etat += nombre;
    } else {                        
// sinon on calcule le nouvel ?tat plus pr?cis?ment
      etat += (nombre - modulo) ;
    }
  }
  
}